diff --git a/target-mips/translate.c b/target-mips/translate.c
index cefccb0..590c2b6 100644
--- a/target-mips/translate.c
+++ b/target-mips/translate.c
@@ -2043,11 +1999,11 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
             tcg_gen_mul_i64(r_tmp1, r_tmp1, r_tmp2);
             tcg_gen_concat_tl_i64(r_tmp2, cpu_LO[0], cpu_HI[0]);
             tcg_gen_add_i64(r_tmp1, r_tmp1, r_tmp2);
-            tcg_temp_free(r_tmp2);
+            tcg_temp_free_i64(r_tmp2);
             tcg_gen_trunc_i64_tl(t0, r_tmp1);
             tcg_gen_shri_i64(r_tmp1, r_tmp1, 32);
             tcg_gen_trunc_i64_tl(t1, r_tmp1);
-            tcg_temp_free(r_tmp1);
+            tcg_temp_free_i64(r_tmp1);
             tcg_gen_ext32s_tl(cpu_LO[0], t0);
             tcg_gen_ext32s_tl(cpu_HI[0], t1);
         }
@@ -2055,19 +2011,19 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
         break;
     case OPC_MSUB:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 r_tmp1 = tcg_temp_new_i64();
+            TCGv_i64 r_tmp2 = tcg_temp_new_i64();
 
             tcg_gen_ext_tl_i64(r_tmp1, t0);
             tcg_gen_ext_tl_i64(r_tmp2, t1);
             tcg_gen_mul_i64(r_tmp1, r_tmp1, r_tmp2);
             tcg_gen_concat_tl_i64(r_tmp2, cpu_LO[0], cpu_HI[0]);
             tcg_gen_sub_i64(r_tmp1, r_tmp1, r_tmp2);
-            tcg_temp_free(r_tmp2);
+            tcg_temp_free_i64(r_tmp2);
             tcg_gen_trunc_i64_tl(t0, r_tmp1);
             tcg_gen_shri_i64(r_tmp1, r_tmp1, 32);
             tcg_gen_trunc_i64_tl(t1, r_tmp1);
-            tcg_temp_free(r_tmp1);
+            tcg_temp_free_i64(r_tmp1);
             tcg_gen_ext32s_tl(cpu_LO[0], t0);
             tcg_gen_ext32s_tl(cpu_HI[0], t1);
         }
@@ -2075,8 +2031,8 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
         break;
     case OPC_MSUBU:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 r_tmp1 = tcg_temp_new_i64();
+            TCGv_i64 r_tmp2 = tcg_temp_new_i64();
 
             tcg_gen_ext32u_tl(t0, t0);
             tcg_gen_ext32u_tl(t1, t1);
@@ -2085,11 +2041,11 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
             tcg_gen_mul_i64(r_tmp1, r_tmp1, r_tmp2);
             tcg_gen_concat_tl_i64(r_tmp2, cpu_LO[0], cpu_HI[0]);
             tcg_gen_sub_i64(r_tmp1, r_tmp1, r_tmp2);
-            tcg_temp_free(r_tmp2);
+            tcg_temp_free_i64(r_tmp2);
             tcg_gen_trunc_i64_tl(t0, r_tmp1);
             tcg_gen_shri_i64(r_tmp1, r_tmp1, 32);
             tcg_gen_trunc_i64_tl(t1, r_tmp1);
-            tcg_temp_free(r_tmp1);
+            tcg_temp_free_i64(r_tmp1);
             tcg_gen_ext32s_tl(cpu_LO[0], t0);
             tcg_gen_ext32s_tl(cpu_HI[0], t1);
         }
@@ -2110,67 +2066,67 @@ static void gen_mul_vr54xx (DisasContext *ctx, uint32_t opc,
                             int rd, int rs, int rt)
 {
     const char *opn = "mul vr54xx";
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
-    TCGv t1 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
+    TCGv t1 = tcg_temp_local_new();
 
     gen_load_gpr(t0, rs);
     gen_load_gpr(t1, rt);
 
     switch (opc) {
     case OPC_VR54XX_MULS:
-        tcg_gen_helper_1_2(do_muls, t0, t0, t1);
+        gen_helper_muls(t0, t0, t1);
         opn = "muls";
 	break;
     case OPC_VR54XX_MULSU:
-        tcg_gen_helper_1_2(do_mulsu, t0, t0, t1);
+        gen_helper_mulsu(t0, t0, t1);
         opn = "mulsu";
 	break;
     case OPC_VR54XX_MACC:
-        tcg_gen_helper_1_2(do_macc, t0, t0, t1);
+        gen_helper_macc(t0, t0, t1);
         opn = "macc";
 	break;
     case OPC_VR54XX_MACCU:
-        tcg_gen_helper_1_2(do_maccu, t0, t0, t1);
+        gen_helper_maccu(t0, t0, t1);
         opn = "maccu";
 	break;
     case OPC_VR54XX_MSAC:
-        tcg_gen_helper_1_2(do_msac, t0, t0, t1);
+        gen_helper_msac(t0, t0, t1);
         opn = "msac";
 	break;
     case OPC_VR54XX_MSACU:
-        tcg_gen_helper_1_2(do_msacu, t0, t0, t1);
+        gen_helper_msacu(t0, t0, t1);
         opn = "msacu";
 	break;
     case OPC_VR54XX_MULHI:
-        tcg_gen_helper_1_2(do_mulhi, t0, t0, t1);
+        gen_helper_mulhi(t0, t0, t1);
         opn = "mulhi";
 	break;
     case OPC_VR54XX_MULHIU:
-        tcg_gen_helper_1_2(do_mulhiu, t0, t0, t1);
+        gen_helper_mulhiu(t0, t0, t1);
         opn = "mulhiu";
 	break;
     case OPC_VR54XX_MULSHI:
-        tcg_gen_helper_1_2(do_mulshi, t0, t0, t1);
+        gen_helper_mulshi(t0, t0, t1);
         opn = "mulshi";
 	break;
     case OPC_VR54XX_MULSHIU:
-        tcg_gen_helper_1_2(do_mulshiu, t0, t0, t1);
+        gen_helper_mulshiu(t0, t0, t1);
         opn = "mulshiu";
 	break;
     case OPC_VR54XX_MACCHI:
-        tcg_gen_helper_1_2(do_macchi, t0, t0, t1);
+        gen_helper_macchi(t0, t0, t1);
         opn = "macchi";
 	break;
     case OPC_VR54XX_MACCHIU:
-        tcg_gen_helper_1_2(do_macchiu, t0, t0, t1);
+        gen_helper_macchiu(t0, t0, t1);
         opn = "macchiu";
 	break;
     case OPC_VR54XX_MSACHI:
-        tcg_gen_helper_1_2(do_msachi, t0, t0, t1);
+        gen_helper_msachi(t0, t0, t1);
         opn = "msachi";
 	break;
     case OPC_VR54XX_MSACHIU:
-        tcg_gen_helper_1_2(do_msachiu, t0, t0, t1);
+        gen_helper_msachiu(t0, t0, t1);
         opn = "msachiu";
 	break;
     default:
@@ -2190,7 +2146,7 @@ static void gen_cl (DisasContext *ctx, uint32_t opc,
                     int rd, int rs)
 {
     const char *opn = "CLx";
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
 
     if (rd == 0) {
         /* Treat as NOP. */
@@ -2200,20 +2156,20 @@ static void gen_cl (DisasContext *ctx, uint32_t opc,
     gen_load_gpr(t0, rs);
     switch (opc) {
     case OPC_CLO:
-        tcg_gen_helper_1_1(do_clo, t0, t0);
+        gen_helper_clo(t0, t0);
         opn = "clo";
         break;
     case OPC_CLZ:
-        tcg_gen_helper_1_1(do_clz, t0, t0);
+        gen_helper_clz(t0, t0);
         opn = "clz";
         break;
 #if defined(TARGET_MIPS64)
     case OPC_DCLO:
-        tcg_gen_helper_1_1(do_dclo, t0, t0);
+        gen_helper_dclo(t0, t0);
         opn = "dclo";
         break;
     case OPC_DCLZ:
-        tcg_gen_helper_1_1(do_dclz, t0, t0);
+        gen_helper_dclz(t0, t0);
         opn = "dclz";
         break;
 #endif
@@ -2234,8 +2190,8 @@ static void gen_trap (DisasContext *ctx, uint32_t opc,
                       int rs, int rt, int16_t imm)
 {
     int cond;
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
-    TCGv t1 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
+    TCGv t1 = tcg_temp_local_new();
 
     cond = 0;
     /* Load needed operands */
@@ -2328,7 +2284,7 @@ static void gen_trap (DisasContext *ctx, uint32_t opc,
         int l1 = gen_new_label();
 
         tcg_gen_brcondi_tl(TCG_COND_EQ, t0, 0, l1);
-        tcg_gen_helper_0_i(do_raise_exception, EXCP_TRAP);
+        gen_helper_0i(raise_exception, EXCP_TRAP);
         gen_set_label(l1);
     }
     ctx->bstate = BS_STOP;
@@ -2358,8 +2314,8 @@ static void gen_compute_branch (DisasContext *ctx, uint32_t opc,
     target_ulong btgt = -1;
     int blink = 0;
     int bcond_compute = 0;
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
-    TCGv t1 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
+    TCGv t1 = tcg_temp_local_new();
 
     if (ctx->hflags & MIPS_HFLAG_BMASK) {
 #ifdef MIPS_DEBUG_DISAS
@@ -2600,8 +2556,8 @@ static void gen_compute_branch (DisasContext *ctx, uint32_t opc,
 static void gen_bitops (DisasContext *ctx, uint32_t opc, int rt,
                         int rs, int lsb, int msb)
 {
-    TCGv t0 = tcg_temp_new(TCG_TYPE_TL);
-    TCGv t1 = tcg_temp_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_new();
+    TCGv t1 = tcg_temp_new();
     target_ulong mask;
 
     gen_load_gpr(t1, rs);
@@ -2691,8 +2647,8 @@ fail:
 
 static void gen_bshfl (DisasContext *ctx, uint32_t op2, int rt, int rd)
 {
-    TCGv t0 = tcg_temp_new(TCG_TYPE_TL);
-    TCGv t1 = tcg_temp_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_new();
+    TCGv t1 = tcg_temp_new();
 
     gen_load_gpr(t1, rt);
     switch (op2) {
@@ -2747,11 +2703,11 @@ static void gen_bshfl (DisasContext *ctx, uint32_t op2, int rt, int rd)
 /* CP0 (MMU and control) */
 static inline void gen_mfc0_load32 (TCGv t, target_ulong off)
 {
-    TCGv r_tmp = tcg_temp_new(TCG_TYPE_I32);
+    TCGv_i32 r_tmp = tcg_temp_new_i32();
 
     tcg_gen_ld_i32(r_tmp, cpu_env, off);
     tcg_gen_ext_i32_tl(t, r_tmp);
-    tcg_temp_free(r_tmp);
+    tcg_temp_free_i32(r_tmp);
 }
 
 static inline void gen_mfc0_load64 (TCGv t, target_ulong off)
@@ -2762,11 +2718,11 @@ static inline void gen_mfc0_load64 (TCGv t, target_ulong off)
 
 static inline void gen_mtc0_store32 (TCGv t, target_ulong off)
 {
-    TCGv r_tmp = tcg_temp_new(TCG_TYPE_I32);
+    TCGv_i32 r_tmp = tcg_temp_new_i32();
 
     tcg_gen_trunc_tl_i32(r_tmp, t);
     tcg_gen_st_i32(r_tmp, cpu_env, off);
-    tcg_temp_free(r_tmp);
+    tcg_temp_free_i32(r_tmp);
 }
 
 static inline void gen_mtc0_store64 (TCGv t, target_ulong off)
@@ -2791,17 +2747,17 @@ static void gen_mfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
             break;
         case 1:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_mvpcontrol, t0);
+            gen_helper_mfc0_mvpcontrol(t0);
             rn = "MVPControl";
             break;
         case 2:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_mvpconf0, t0);
+            gen_helper_mfc0_mvpconf0(t0);
             rn = "MVPConf0";
             break;
         case 3:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_mvpconf1, t0);
+            gen_helper_mfc0_mvpconf1(t0);
             rn = "MVPConf1";
             break;
         default:
@@ -2811,7 +2767,7 @@ static void gen_mfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 1:
         switch (sel) {
         case 0:
-            tcg_gen_helper_1_0(do_mfc0_random, t0);
+            gen_helper_mfc0_random(t0);
             rn = "Random";
             break;
         case 1:
@@ -2862,37 +2818,37 @@ static void gen_mfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
             break;
         case 1:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_tcstatus, t0);
+            gen_helper_mfc0_tcstatus(t0);
             rn = "TCStatus";
             break;
         case 2:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_tcbind, t0);
+            gen_helper_mfc0_tcbind(t0);
             rn = "TCBind";
             break;
         case 3:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_tcrestart, t0);
+            gen_helper_mfc0_tcrestart(t0);
             rn = "TCRestart";
             break;
         case 4:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_tchalt, t0);
+            gen_helper_mfc0_tchalt(t0);
             rn = "TCHalt";
             break;
         case 5:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_tccontext, t0);
+            gen_helper_mfc0_tccontext(t0);
             rn = "TCContext";
             break;
         case 6:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_tcschedule, t0);
+            gen_helper_mfc0_tcschedule(t0);
             rn = "TCSchedule";
             break;
         case 7:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_tcschefback, t0);
+            gen_helper_mfc0_tcschefback(t0);
             rn = "TCScheFBack";
             break;
         default:
@@ -2918,7 +2874,7 @@ static void gen_mfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
             rn = "Context";
             break;
         case 1:
-//            tcg_gen_helper_1_0(do_mfc0_contextconfig, t0); /* SmartMIPS ASE */
+//            gen_helper_mfc0_contextconfig(t0); /* SmartMIPS ASE */
             rn = "ContextConfig";
 //            break;
         default:
@@ -3003,7 +2959,7 @@ static void gen_mfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
             /* Mark as an IO operation because we read the time.  */
             if (use_icount)
                 gen_io_start();
-            tcg_gen_helper_1_0(do_mfc0_count, t0);
+            gen_helper_mfc0_count(t0);
             if (use_icount) {
                 gen_io_end();
                 ctx->bstate = BS_STOP;
@@ -3133,7 +3089,7 @@ static void gen_mfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 17:
         switch (sel) {
         case 0:
-            tcg_gen_helper_1_0(do_mfc0_lladdr, t0);
+            gen_helper_mfc0_lladdr(t0);
             rn = "LLAddr";
             break;
         default:
@@ -3143,7 +3099,7 @@ static void gen_mfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 18:
         switch (sel) {
         case 0 ... 7:
-            tcg_gen_helper_1_i(do_mfc0_watchlo, t0, sel);
+            gen_helper_1i(mfc0_watchlo, t0, sel);
             rn = "WatchLo";
             break;
         default:
@@ -3153,7 +3109,7 @@ static void gen_mfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 19:
         switch (sel) {
         case 0 ...7:
-            tcg_gen_helper_1_i(do_mfc0_watchhi, t0, sel);
+            gen_helper_1i(mfc0_watchhi, t0, sel);
             rn = "WatchHi";
             break;
         default:
@@ -3192,23 +3148,23 @@ static void gen_mfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 23:
         switch (sel) {
         case 0:
-            tcg_gen_helper_1_0(do_mfc0_debug, t0); /* EJTAG support */
+            gen_helper_mfc0_debug(t0); /* EJTAG support */
             rn = "Debug";
             break;
         case 1:
-//            tcg_gen_helper_1_0(do_mfc0_tracecontrol, t0); /* PDtrace support */
+//            gen_helper_mfc0_tracecontrol(t0); /* PDtrace support */
             rn = "TraceControl";
 //            break;
         case 2:
-//            tcg_gen_helper_1_0(do_mfc0_tracecontrol2, t0); /* PDtrace support */
+//            gen_helper_mfc0_tracecontrol2(t0); /* PDtrace support */
             rn = "TraceControl2";
 //            break;
         case 3:
-//            tcg_gen_helper_1_0(do_mfc0_usertracedata, t0); /* PDtrace support */
+//            gen_helper_mfc0_usertracedata(t0); /* PDtrace support */
             rn = "UserTraceData";
 //            break;
         case 4:
-//            tcg_gen_helper_1_0(do_mfc0_tracebpc, t0); /* PDtrace support */
+//            gen_helper_mfc0_tracebpc(t0); /* PDtrace support */
             rn = "TraceBPC";
 //            break;
         default:
@@ -3234,31 +3190,31 @@ static void gen_mfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
             rn = "Performance0";
             break;
         case 1:
-//            tcg_gen_helper_1_0(do_mfc0_performance1, t0);
+//            gen_helper_mfc0_performance1(t0);
             rn = "Performance1";
 //            break;
         case 2:
-//            tcg_gen_helper_1_0(do_mfc0_performance2, t0);
+//            gen_helper_mfc0_performance2(t0);
             rn = "Performance2";
 //            break;
         case 3:
-//            tcg_gen_helper_1_0(do_mfc0_performance3, t0);
+//            gen_helper_mfc0_performance3(t0);
             rn = "Performance3";
 //            break;
         case 4:
-//            tcg_gen_helper_1_0(do_mfc0_performance4, t0);
+//            gen_helper_mfc0_performance4(t0);
             rn = "Performance4";
 //            break;
         case 5:
-//            tcg_gen_helper_1_0(do_mfc0_performance5, t0);
+//            gen_helper_mfc0_performance5(t0);
             rn = "Performance5";
 //            break;
         case 6:
-//            tcg_gen_helper_1_0(do_mfc0_performance6, t0);
+//            gen_helper_mfc0_performance6(t0);
             rn = "Performance6";
 //            break;
         case 7:
-//            tcg_gen_helper_1_0(do_mfc0_performance7, t0);
+//            gen_helper_mfc0_performance7(t0);
             rn = "Performance7";
 //            break;
         default:
@@ -3376,12 +3332,12 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 0:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_index, t0);
+            gen_helper_mtc0_index(t0);
             rn = "Index";
             break;
         case 1:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_mvpcontrol, t0);
+            gen_helper_mtc0_mvpcontrol(t0);
             rn = "MVPControl";
             break;
         case 2:
@@ -3406,22 +3362,22 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
             break;
         case 1:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_vpecontrol, t0);
+            gen_helper_mtc0_vpecontrol(t0);
             rn = "VPEControl";
             break;
         case 2:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_vpeconf0, t0);
+            gen_helper_mtc0_vpeconf0(t0);
             rn = "VPEConf0";
             break;
         case 3:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_vpeconf1, t0);
+            gen_helper_mtc0_vpeconf1(t0);
             rn = "VPEConf1";
             break;
         case 4:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_yqmask, t0);
+            gen_helper_mtc0_yqmask(t0);
             rn = "YQMask";
             break;
         case 5:
@@ -3436,7 +3392,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
             break;
         case 7:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_vpeopt, t0);
+            gen_helper_mtc0_vpeopt(t0);
             rn = "VPEOpt";
             break;
         default:
@@ -3446,42 +3402,42 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 2:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_entrylo0, t0);
+            gen_helper_mtc0_entrylo0(t0);
             rn = "EntryLo0";
             break;
         case 1:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tcstatus, t0);
+            gen_helper_mtc0_tcstatus(t0);
             rn = "TCStatus";
             break;
         case 2:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tcbind, t0);
+            gen_helper_mtc0_tcbind(t0);
             rn = "TCBind";
             break;
         case 3:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tcrestart, t0);
+            gen_helper_mtc0_tcrestart(t0);
             rn = "TCRestart";
             break;
         case 4:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tchalt, t0);
+            gen_helper_mtc0_tchalt(t0);
             rn = "TCHalt";
             break;
         case 5:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tccontext, t0);
+            gen_helper_mtc0_tccontext(t0);
             rn = "TCContext";
             break;
         case 6:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tcschedule, t0);
+            gen_helper_mtc0_tcschedule(t0);
             rn = "TCSchedule";
             break;
         case 7:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tcschefback, t0);
+            gen_helper_mtc0_tcschefback(t0);
             rn = "TCScheFBack";
             break;
         default:
@@ -3491,7 +3447,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 3:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_entrylo1, t0);
+            gen_helper_mtc0_entrylo1(t0);
             rn = "EntryLo1";
             break;
         default:
@@ -3501,11 +3457,11 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 4:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_context, t0);
+            gen_helper_mtc0_context(t0);
             rn = "Context";
             break;
         case 1:
-//            tcg_gen_helper_0_1(do_mtc0_contextconfig, t0); /* SmartMIPS ASE */
+//            gen_helper_mtc0_contextconfig(t0); /* SmartMIPS ASE */
             rn = "ContextConfig";
 //            break;
         default:
@@ -3515,12 +3471,12 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 5:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_pagemask, t0);
+            gen_helper_mtc0_pagemask(t0);
             rn = "PageMask";
             break;
         case 1:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_pagegrain, t0);
+            gen_helper_mtc0_pagegrain(t0);
             rn = "PageGrain";
             break;
         default:
@@ -3530,32 +3486,32 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 6:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_wired, t0);
+            gen_helper_mtc0_wired(t0);
             rn = "Wired";
             break;
         case 1:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsconf0, t0);
+            gen_helper_mtc0_srsconf0(t0);
             rn = "SRSConf0";
             break;
         case 2:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsconf1, t0);
+            gen_helper_mtc0_srsconf1(t0);
             rn = "SRSConf1";
             break;
         case 3:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsconf2, t0);
+            gen_helper_mtc0_srsconf2(t0);
             rn = "SRSConf2";
             break;
         case 4:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsconf3, t0);
+            gen_helper_mtc0_srsconf3(t0);
             rn = "SRSConf3";
             break;
         case 5:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsconf4, t0);
+            gen_helper_mtc0_srsconf4(t0);
             rn = "SRSConf4";
             break;
         default:
@@ -3566,7 +3522,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
         switch (sel) {
         case 0:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_hwrena, t0);
+            gen_helper_mtc0_hwrena(t0);
             rn = "HWREna";
             break;
         default:
@@ -3580,7 +3536,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 9:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_count, t0);
+            gen_helper_mtc0_count(t0);
             rn = "Count";
             break;
         /* 6,7 are implementation dependent */
@@ -3593,7 +3549,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 10:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_entryhi, t0);
+            gen_helper_mtc0_entryhi(t0);
             rn = "EntryHi";
             break;
         default:
@@ -3603,7 +3559,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 11:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_compare, t0);
+            gen_helper_mtc0_compare(t0);
             rn = "Compare";
             break;
         /* 6,7 are implementation dependent */
@@ -3616,7 +3572,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 12:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_status, t0);
+            gen_helper_mtc0_status(t0);
             /* BS_STOP isn't good enough here, hflags may have changed. */
             gen_save_pc(ctx->pc + 4);
             ctx->bstate = BS_EXCP;
@@ -3624,14 +3580,14 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
             break;
         case 1:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_intctl, t0);
+            gen_helper_mtc0_intctl(t0);
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
             rn = "IntCtl";
             break;
         case 2:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsctl, t0);
+            gen_helper_mtc0_srsctl(t0);
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
             rn = "SRSCtl";
@@ -3650,7 +3606,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 13:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_cause, t0);
+            gen_helper_mtc0_cause(t0);
             rn = "Cause";
             break;
         default:
@@ -3677,7 +3633,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
             break;
         case 1:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_ebase, t0);
+            gen_helper_mtc0_ebase(t0);
             rn = "EBase";
             break;
         default:
@@ -3687,7 +3643,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 16:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_config0, t0);
+            gen_helper_mtc0_config0(t0);
             rn = "Config";
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
@@ -3697,7 +3653,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
             rn = "Config1";
             break;
         case 2:
-            tcg_gen_helper_0_1(do_mtc0_config2, t0);
+            gen_helper_mtc0_config2(t0);
             rn = "Config2";
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
@@ -3734,7 +3690,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 18:
         switch (sel) {
         case 0 ... 7:
-            tcg_gen_helper_0_1i(do_mtc0_watchlo, t0, sel);
+            gen_helper_1i(mtc0_watchlo, t0, sel);
             rn = "WatchLo";
             break;
         default:
@@ -3744,7 +3700,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 19:
         switch (sel) {
         case 0 ... 7:
-            tcg_gen_helper_0_1i(do_mtc0_watchhi, t0, sel);
+            gen_helper_1i(mtc0_watchhi, t0, sel);
             rn = "WatchHi";
             break;
         default:
@@ -3756,7 +3712,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
         case 0:
 #if defined(TARGET_MIPS64)
             check_insn(env, ctx, ISA_MIPS3);
-            tcg_gen_helper_0_1(do_mtc0_xcontext, t0);
+            gen_helper_mtc0_xcontext(t0);
             rn = "XContext";
             break;
 #endif
@@ -3768,7 +3724,7 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
        /* Officially reserved, but sel 0 is used for R1x000 framemask */
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_framemask, t0);
+            gen_helper_mtc0_framemask(t0);
             rn = "Framemask";
             break;
         default:
@@ -3782,20 +3738,20 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 23:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_debug, t0); /* EJTAG support */
+            gen_helper_mtc0_debug(t0); /* EJTAG support */
             /* BS_STOP isn't good enough here, hflags may have changed. */
             gen_save_pc(ctx->pc + 4);
             ctx->bstate = BS_EXCP;
             rn = "Debug";
             break;
         case 1:
-//            tcg_gen_helper_0_1(do_mtc0_tracecontrol, t0); /* PDtrace support */
+//            gen_helper_mtc0_tracecontrol(t0); /* PDtrace support */
             rn = "TraceControl";
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
 //            break;
         case 2:
-//            tcg_gen_helper_0_1(do_mtc0_tracecontrol2, t0); /* PDtrace support */
+//            gen_helper_mtc0_tracecontrol2(t0); /* PDtrace support */
             rn = "TraceControl2";
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
@@ -3803,13 +3759,13 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
         case 3:
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
-//            tcg_gen_helper_0_1(do_mtc0_usertracedata, t0); /* PDtrace support */
+//            gen_helper_mtc0_usertracedata(t0); /* PDtrace support */
             rn = "UserTraceData";
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
 //            break;
         case 4:
-//            tcg_gen_helper_0_1(do_mtc0_tracebpc, t0); /* PDtrace support */
+//            gen_helper_mtc0_tracebpc(t0); /* PDtrace support */
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
             rn = "TraceBPC";
@@ -3832,35 +3788,35 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
     case 25:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_performance0, t0);
+            gen_helper_mtc0_performance0(t0);
             rn = "Performance0";
             break;
         case 1:
-//            tcg_gen_helper_0_1(do_mtc0_performance1, t0);
+//            gen_helper_mtc0_performance1(t0);
             rn = "Performance1";
 //            break;
         case 2:
-//            tcg_gen_helper_0_1(do_mtc0_performance2, t0);
+//            gen_helper_mtc0_performance2(t0);
             rn = "Performance2";
 //            break;
         case 3:
-//            tcg_gen_helper_0_1(do_mtc0_performance3, t0);
+//            gen_helper_mtc0_performance3(t0);
             rn = "Performance3";
 //            break;
         case 4:
-//            tcg_gen_helper_0_1(do_mtc0_performance4, t0);
+//            gen_helper_mtc0_performance4(t0);
             rn = "Performance4";
 //            break;
         case 5:
-//            tcg_gen_helper_0_1(do_mtc0_performance5, t0);
+//            gen_helper_mtc0_performance5(t0);
             rn = "Performance5";
 //            break;
         case 6:
-//            tcg_gen_helper_0_1(do_mtc0_performance6, t0);
+//            gen_helper_mtc0_performance6(t0);
             rn = "Performance6";
 //            break;
         case 7:
-//            tcg_gen_helper_0_1(do_mtc0_performance7, t0);
+//            gen_helper_mtc0_performance7(t0);
             rn = "Performance7";
 //            break;
         default:
